********************************************************************
* Download and extract time series from the FoF and from FRED
* and save them to a csv file for matlab use
*
* Arguments:
*   - `1': name of the CSV file where the extract should be saved
*
* Last modified: February 25th, 2015
********************************************************************

# delimit cr
clear
clear mata 
set scheme s2color

/*
foreach package in "labutil" {
 		capture which `package'
 		if _rc==111 ssc install `package'
}
*/

global RootPath `"`c(pwd)'"'
global matlabExtract = "$RootPath/matlabExtractFoF.csv"
global TempFoF = "$RootPath/FoF_download_03172015.dta"

/* Download and format FoF data */
*do "$RootPath/downloadFoF.do" "$TempFoF"
use "$TempFoF", clear

# delimit ;
keep 
	fyear
	quart
	date
	l_depositoryinstitloans
    l_otherloans
	l_creditmarketinstruments
	f_capex
	a_tot_fin
	l_tot_fin
	;
# delimit cr
	
rename fyear year
rename quart quarter

outsheet year quarter l_depositoryinstitloans l_otherloans l_creditmarketinstruments f_capex using "$matlabExtract", comma nolabel replace
