function HN = HN_fun(e,s,k,a,b,r_m,z,pars)

nogood = (e < 0 | k < 0); numargs_e = numel(e); numargs_k = numel(k); numargs_a = numel(a); numargs_b = numel(b);

if sum(nogood) > 0
    fprintf('e < 0 or k < 0 in HN_fun \n');
end;

if ( numargs_e ~= numargs_k || numargs_e ~= numargs_a || numargs_e ~= numargs_b )
    fprintf('e, k, a and b do not have the same number of elements in HN_fun \n');
end;

r_hat_m = (1+pars.r)*(1-s)/(1-pars.chi) - 1;
r_tilde_m = (1+r_m).*(1-s)./(1-pars.chi) - 1;
chi_m = z(:,(end-2));
delta_hat = 1-(pars.chi_L - chi_m)./(1-chi_m).*(1-pars.delta_k);

case0 = ( e > 0 )&( k > 0 )&( k < e );
case1 = ( r_tilde_m + delta_hat > 0  )&( ( e > 0 )&( k >= e  )&( k < (1+r_tilde_m)./(delta_hat+r_tilde_m).*e ) );
case2 = ( r_tilde_m + delta_hat > 0  )&( ( ( e > 0 )&( k >= ((1+r_tilde_m)./(delta_hat+r_tilde_m).*e) ) ) | ( e == 0 )&( k > 0) );
case3 = ( r_tilde_m + delta_hat <= 0 )&( ( ( e > 0 )&( k >= e  ) | ( e == 0 )&( k > 0 ) ) );
case4 = ( e==0 & k==0 );

phi_d = NaN(numargs_e,1);

if sum(case0) > 0 
    phi_d(case0) = (r_hat_m(case0)+delta_hat(case0)).*(k(case0).^(-pars.zeta)).*(k(case0) - (1+r_hat_m(case0))./(delta_hat(case0)+r_hat_m(case0)).*e(case0));
end;

if sum(case1) > 0
    phi_d(case1) = (r_tilde_m(case1)+delta_hat(case1)).*(k(case1).^(-pars.zeta)).*(k(case1) - (1+r_tilde_m(case1))./(delta_hat(case1)+r_tilde_m(case1)).*e(case1));
end;

if sum(case2) > 0   
    phi_d_low  = zeros(sum(case2),1);
    phi_d_high = maximum_default_m(k(case2),a(case2),b(case2),z(case2,:),pars);
    k2 = k(case2); e2 = e(case2); a2 = a(case2); b2 = b(case2); r_tilde_m2 = r_tilde_m(case2); delta_hat2 = delta_hat(case2);
    ff = @(x,indexes) N_fun(x,-(1-delta_hat2(indexes)).*((k2(indexes)).^(1-pars.zeta)),a2(indexes),b2(indexes),pars) - (k2(indexes).^(-pars.zeta)).*(delta_hat2(indexes)+r_tilde_m2(indexes)).*(k2(indexes) - (1+r_tilde_m2(indexes))./(delta_hat2(indexes)+r_tilde_m2(indexes)).*e2(indexes));
    x_low = phi_d_low; x_high = phi_d_high; tol_f = pars.tol_f_contr; tol_x = pars.tol_x_contr;
    return_warning{1} = true; return_warning{2} = 'HN_fun';
    phi_d(case2) = bissection(x_low,x_high,ff,tol_f,tol_x,return_warning);
end;

if sum(case3) > 0
    phi_d(case3)  = (r_tilde_m(case3)+delta_hat(case3)).*(k(case3).^(1-pars.zeta)) - (1+r_tilde_m(case3)).*e(case3).*k(case3).^(-pars.zeta);    
end;

if sum(case4) > 0
    phi_d = 0;
end;

HN = H_fun(phi_d,a,b);

if sum(isnan(HN)) > 0
    fprintf('HN returned NaN \n');
end;

end

