function [k_max,dk_maxds,dk_maxde] = borrowing_constraint(s,e,z,pars,s_r,s_fm,s_mb)

numargs = numel(s); k_max = NaN(size(s)); dk_maxds = k_max; dk_maxde = k_max;

if ( numargs ~= numel(e) || numargs ~= size(z,1) )
    error('Arguments do not have the same size in borrowing_constraint \n');
end;

if nargin < 5
    [s_r,s_fm,s_mb] = thresholds_s( e, z, pars );
end;

case0 = (s == 0);
case1 = ( s >= s_r )&( s < s_fm );
case2 = ( s >= s_fm )&( s < s_mb );
case3 = ( s >= s_mb )&( s <= 1 );

if sum(case0+case1+case2+case3) ~= numargs
    error('Unexpected cases in borrowing_constraint \n');
end;

if sum(case0) > 0
    [k_max(case0),dk_maxds(case0),dk_maxde(case0)] = borrowing_constraint_nr(s(case0),e(case0),z(case0,:),pars);
end;
if sum(case1) > 0
    [k_max(case1),dk_maxds(case1),dk_maxde(case1)] = borrowing_constraint_f(s(case1),e(case1),z(case1,:),pars);
end;
if sum(case2) > 0
    [k_max(case2),dk_maxds(case2),dk_maxde(case2)] = borrowing_constraint_m(s(case2),e(case2),z(case2,:),pars);
end;
if sum(case3) > 0
    [k_max(case3),dk_maxds(case3),dk_maxde(case3)] = borrowing_constraint_b(s(case3),e(case3),z(case3,:),pars);
end;

end

