function [k_max,dk_maxds,dk_maxde] = borrowing_constraint_b(s,e,z,pars)

nogood = (e < 0); 

if sum(nogood) > 0
    fprintf('e < 0 in borrowing_constraint_b \n');
end;

a = z(:,1); b = z(:,2);
E_phi = a.*gamma(1+1./b);
r_tilde_b = (1+pars.r_b)*s/pars.chi-1;

case1 = ((r_tilde_b + pars.delta_k) <= 0);
case2 = (~case1);

k_max = NaN(numel(e),1); dk_maxds = k_max; dk_maxde = k_max;

if sum(case1) > 0
    
    k_max(case1)       = Inf;
    dk_maxds(case1)    = 0;
    dk_maxde(case1)    = 0;
    
end;
    
if sum(case2) > 0
    
    A                  = E_phi(case2)./(pars.delta_k+r_tilde_b(case2));
    B                  = (1+r_tilde_b(case2))./(r_tilde_b(case2)+pars.delta_k).*e(case2);
    tol_f = pars.tol_f_maxk; tol_x = pars.tol_x_maxk;
    k_max(case2)       = find_root_fractional(A,B,tol_x,tol_f,pars);
    dk_maxds(case2)    = (1+pars.r_b)/pars.chi*(k_max(case2) - e(case2)).*( 1./( pars.zeta*E_phi(case2).*k_max(case2).^(pars.zeta-1) - ( r_tilde_b(case2) + pars.delta_k ) ) );
    dk_maxde(case2)    = -(1+r_tilde_b(case2)).*( 1./( pars.zeta*E_phi(case2).*k_max(case2).^(pars.zeta-1) - (r_tilde_b+pars.delta_k) ));
    
end;

end