function [MM,liq_rate] = compute_transition_matrix( next_e, z, phi_d_r, phi_b, k_hat_r, phi_d_nr, k_hat_nr, s_hat_r, pars )

a = z(:,1); b = z(:,2); ppi = z(:,3:end);
N = size(next_e,1); M = size(next_e,2);
MM = NaN(N,N); liq_rate = zeros(N,M);

phi_x_nr = phi_d_nr - (1-pars.chi_L).*(1-pars.delta_k).*k_hat_nr.^(1-pars.zeta);

for m=1:M
    
    for ii=1:N

        proba_handle = @(phi) (phi < 0).*zeros(size(phi)) + (phi >= 0).*( 1 - exp( -(phi./a((m-1)*N+ii)).^(b((m-1)*N+ii))  ) );

        if isnan(s_hat_r(ii,m)) %no renegotiation region

            liq_rate(ii,m) = proba_handle(phi_d_nr(ii,m)); 

            for m_p=1:M

                for jj=1:N

                   if jj==1

                        MM((m-1)*N+ii,(m_p-1)*N+1) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(phi_x_nr(ii,m) + 1/(1-pars.tau)*k_hat_nr(ii,m).^(-pars.zeta)*(1/2)*(next_e(2,m_p)+next_e(1,m_p))) - liq_rate(ii,m));
                        if MM((m-1)*N+ii,(m_p-1)*N+1) < 0
                            MM((m-1)*N+ii,(m_p-1)*N+1) = 0;
                        end;

                   elseif jj >= 2 && jj < N

                        MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(phi_x_nr(ii,m) + 1/(1-pars.tau)* k_hat_nr(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj+1,m_p)+next_e(jj,m_p))) - proba_handle(phi_x_nr(ii,m) + 1/(1-pars.tau)*k_hat_nr(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))));
                        if MM((m-1)*N+ii,(m_p-1)*N+1) < 0
                            MM((m-1)*N+ii,(m_p-1)*N+1) = 0;
                        end;
                        
                   else

                        MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*( 1 - proba_handle(phi_x_nr(ii,m) + 1/(1-pars.tau)*k_hat_nr(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))) );
                        if MM((m-1)*N+ii,(m_p-1)*N+1) < 0
                            MM((m-1)*N+ii,(m_p-1)*N+1) = 0;
                        end;

                   end;

                end;

            end;

        end;

        if ~isnan(s_hat_r(ii,m)) %renegotiation region

            liq_rate(ii,m) = proba_handle(phi_d_r(ii,m));

            phi_b_iter = phi_b(ii,m);
            if abs(cdf(pars.FF{m},phi_b_iter)-1) < 1e-9
                phi_b_iter = Inf;
            end;
            
            for m_p=1:M

                jj_ii = find( (1/2)*(next_e(2:end,m_p)+next_e(1:(end-1),m_p)) > (1-pars.chi)*(phi_b_iter - phi_d_r(ii,m))*(1-pars.tau)*k_hat_r(ii,m)^(pars.zeta),1,'first') - 1;
                if isempty(jj_ii)
                    jj_ii = N;
                end;

                if jj_ii == N

                    for jj=1:N

                        if jj==1

                            MM((m-1)*N+ii,(m_p-1)*N+1) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(2,m_p)+next_e(1,m_p))) - liq_rate(ii,m));

                        elseif jj >= 2 && jj < N

                            MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj+1,m_p)+next_e(jj,m_p))) - proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))));

                        elseif jj == N

                            MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(1 - proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))));

                        end;

                    end;

                end;

                if jj_ii < N

                    for jj=1:N

                        if jj==1

                            MM((m-1)*N+ii,(m_p-1)*N+1) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(2,m_p)+next_e(1,m_p))) - liq_rate(ii,m));

                        elseif jj >= 2 && jj < jj_ii

                            MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj+1,m_p)+next_e(jj,m_p))) - proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*(1-pars.chi))*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))));

                        elseif jj == jj_ii

                             MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(pars.chi*phi_b_iter +  (1-pars.chi)*phi_d_r(ii,m) + 1/(1-pars.tau)*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj+1,m_p)+next_e(jj,m_p))) - proba_handle(phi_d_r(ii,m) + 1/((1-pars.tau)*1-pars.chi)*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))));

                        elseif jj > jj_ii && jj < N

                             MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*(proba_handle(pars.chi*phi_b_iter +  (1-pars.chi)*phi_d_r(ii,m) + 1/(1-pars.tau)*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj+1,m_p)+next_e(jj,m_p))) - proba_handle(pars.chi*phi_b_iter +  (1-pars.chi)*phi_d_r(ii,m) + 1/(1-pars.tau)*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))));

                        else

                            MM((m-1)*N+ii,(m_p-1)*N+jj) = ppi((m-1)*N+ii,m_p)*(1-pars.eta)*( 1 - proba_handle(pars.chi*phi_b_iter +  (1-pars.chi)*phi_d_r(ii,m) + 1/(1-pars.tau)*k_hat_r(ii,m).^(-pars.zeta)*(1/2)*(next_e(jj,m_p)+next_e(jj-1,m_p))) );

                        end;

                    end;

                end;
            
            end;

        end;
        
        liq_rate(ii,m) = (1-pars.eta)*liq_rate(ii,m) + pars.eta;
        
    end;

end;

end

