function FD_moments = computing_FD_moments( FD_index, policy_functions, pars )

FD_moments = {};

e_H                         = policy_functions.e(:,FD_index); 
s_R_H                       = policy_functions.s_hat_r(:,FD_index);
d_R_H                       = policy_functions.k_hat_r(:,FD_index) - e_H;
d_K_H                       = policy_functions.k_hat_nr(:,FD_index) - e_H;
index_last_H                = sum(~isnan(s_R_H));
phi_d_r_H                   = policy_functions.phi_d_r(:,FD_index);
phi_d_nr_H                  = policy_functions.phi_d_nr(:,FD_index);
phi_b_H                     = policy_functions.phi_b(:,FD_index);
k_hat_r                     = policy_functions.k_hat_r;
k_hat_nr                    = policy_functions.k_hat_nr;
e                           = policy_functions.e;
e_div                       = e(end,:);

GG                          = pars.FF{FD_index};
phi                         = random(GG,1e4,1);
Profit_rate_vec_H_R         = NaN(size(e_H));
Profit_rate_vec_H_K         = NaN(size(e_H));
Dividend_rate_vec_H_R       = NaN(size(e_H));
Dividend_rate_vec_H_K       = NaN(size(e_H));
G_equity_vec_H_R            = NaN(size(e_H));
G_equity_vec_H_K            = NaN(size(e_H));
V_equity_vec_H_R            = NaN(size(e_H));
V_equity_vec_H_K            = NaN(size(e_H));
G_asset_vec_H_R             = NaN(size(e_H));
G_asset_vec_H_K             = NaN(size(e_H));
G_output_vec_H_R            = NaN(size(e_H));
G_output_vec_H_K            = NaN(size(e_H));

edges = NaN(pars.N_z,size(e_H,1)+1);
k_hat = k_hat_r;
for ii=1:pars.N_z
    kk = k_hat_r(:,ii);
    k_hat(isnan(kk),ii) = k_hat_nr(isnan(kk),ii);
    edges(ii,:) = [-Inf, mean([e(2:end,ii)'; e(1:end-1,ii)']), +Inf];
end;

for ii=1:numel(e_H)
    
    if ii < index_last_H
        
        phi_d = phi_d_r_H(ii)*ones(size(phi));
        k = (e_H(ii)+d_R_H(ii))*ones(size(phi));
        phi_b = phi_b_H(ii)*ones(size(phi));
        s = 1*ones(size(phi));
        n = net_income(phi,phi_d,phi_b,k,s,pars);
        Profit_rate_vec_H_R(ii) = 1/k*1/numel(phi)*sum(n(n>=0));
        DV = NaN(pars.N_z,1);
        DE = NaN(pars.N_z,1);
        DE2 = NaN(pars.N_z,1);
        DK = NaN(pars.N_z,1);
        DY = NaN(pars.N_z,1);
        for jj=1:pars.N_z
            div_issue = (n(n>=e_div(jj)) - e_div(jj))/k;
            ep = n; ep(n >=e_div(jj)) = e_div(jj); gep = (ep - e_H(ii))/k;
            I = discretize(ep,edges(jj,:));
            kp = k_hat(I,jj); 
            yp = pars.E_phi(jj)*k_hat(I,jj).^(pars.zeta);
            y = (phi.*k(1)).^(pars.zeta);
            gyp = (yp - y)./y;
            gkp = (kp - k(1))/k(1);
            gep(n <= 0) = 0;
            gkp(n <= 0) = 0;
            div_issue(n <= e_div(jj)) = 0;
            gyp(n <= 0) = 0;
            DV(jj) = 1/numel(phi)*sum(div_issue);
            DE(jj) = 1/numel(phi)*sum(gep);
            DE2(jj)= 1/numel(phi)*sum(gep.^2);
            DK(jj)= 1/numel(phi)*sum(gkp);
            DY(jj)= 1/numel(phi)*sum(gyp);
        end;
        Dividend_rate_vec_H_R(ii)       = sum((pars.ppi(FD_index,:)').*DV);
        G_equity_vec_H_R(ii)            = sum((pars.ppi(FD_index,:)').*DE);
        V_equity_vec_H_R(ii)            = sqrt(sum((pars.ppi(FD_index,:)').*DE2) - G_equity_vec_H_R(ii)^2);
        G_asset_vec_H_R(ii)             = sum((pars.ppi(FD_index,:)').*DK);
        G_output_vec_H_R(ii)            = sum((pars.ppi(FD_index,:)').*DY);
        
    end;

   if ii==index_last_H

        phi_d = phi_d_r_H(ii)*ones(size(phi));
        k = (e_H(ii)+d_R_H(ii))*ones(size(phi));
        phi_b = phi_b_H(ii)*ones(size(phi));
        s = 1;
        n = net_income(phi,phi_d,phi_b,k,s,pars);
        Profit_rate_vec_H_R(ii) = 1/e_H(ii)*1/numel(phi)*sum(n(n>=0));
        DV = NaN(FD_index,1);
        DE = NaN(FD_index,1);
        DE2 = NaN(FD_index,1);
        DK = NaN(FD_index,1);
        for jj=1:pars.N_z
            div_issue = (n(n>=e_div(jj)) - e_div(jj))/e_H(ii);
            ep = n; ep(n >=e_div(jj)) = e_div(jj); gep = (ep - e_H(ii))/e_H(ii);
            I = discretize(ep,edges(jj,:));
            kp = k_hat(I,jj); 
            yp = pars.E_phi(jj)*k_hat(I,jj).^(pars.zeta);
            y = (phi.*k(1)).^(pars.zeta);
            gyp = (yp - y)./y;
            gkp = (kp - k(1))/k(1);
            gep(n <= 0) = 0;
            gkp(n <= 0) = 0;
            div_issue(n <= e_div(jj)) = 0;
            gyp(n <= 0) = 0;
            DV(jj) = 1/numel(phi)*sum(div_issue);
            DE(jj) = 1/numel(phi)*sum(gep);
            DE2(jj)= 1/numel(phi)*sum(gep.^2);
            DK(jj)= 1/numel(phi)*sum(gkp);
            DY(jj)= 1/numel(phi)*sum(gyp);
        end;
        Dividend_rate_vec_H_R(ii)           = sum((pars.ppi(FD_index,:)').*DV);
        G_equity_vec_H_R(ii)                = sum((pars.ppi(FD_index,:)').*DE);
        V_equity_vec_H_R(ii)                = sqrt(sum((pars.ppi(FD_index,:)').*DE2) - G_equity_vec_H_R(ii)^2);
        G_asset_vec_H_R(ii)                 = sum((pars.ppi(FD_index,:)').*DK);
        G_output_vec_H_R(ii)                = sum((pars.ppi(FD_index,:)').*DY);

        phi_d = phi_d_nr_H(ii)*ones(size(phi));
        k = (e_H(ii)+d_K_H(ii))*ones(size(phi));
        s = 0*ones(size(phi));
        n = net_income(phi,phi_d,phi_b,k,s,pars);
        Profit_rate_vec_H_K(ii) = 1/e_H(ii)*1/numel(phi)*sum(n(n>=0));
        DV = NaN(pars.N_z,1);
        DE = NaN(pars.N_z,1);
        DE2 = NaN(pars.N_z,1);
        DK = NaN(pars.N_z,1);
        DY = NaN(pars.N_z,1);
        for jj=1:pars.N_z
            div_issue = (n(n>=e_div(jj)) - e_div(jj))/e_H(ii);
            ep = n; ep(n >=e_div(jj)) = e_div(jj); gep = (ep - e_H(ii))/e_H(ii);
            I = discretize(ep,edges(jj,:));
            kp = k_hat(I,jj); 
            yp = pars.E_phi(jj)*k_hat(I,jj).^(pars.zeta);
            y = (phi.*k(1)).^(pars.zeta);
            gyp = (yp - y)./y;
            gkp = (kp - k(1))/k(1);
            gep(n <= 0) = 0;
            gkp(n <= 0) = 0;
            div_issue(n <= e_div(jj)) = 0;
            gyp(n <= 0) = 0;
            DV(jj) = 1/numel(phi)*sum(div_issue);
            DE(jj) = 1/numel(phi)*sum(gep);
            DE2(jj)= 1/numel(phi)*sum(gep.^2);
            DK(jj)= 1/numel(phi)*sum(gkp);
            DY(jj)= 1/numel(phi)*sum(gyp);
        end;
        Dividend_rate_vec_H_K(ii)           = sum((pars.ppi(FD_index,:)').*DV);
        G_equity_vec_H_K(ii)                = sum((pars.ppi(FD_index,:)').*DE);
        G_asset_vec_H_K(ii)                 = sum((pars.ppi(FD_index,:)').*DK);
        G_output_vec_H_K(ii)                = sum((pars.ppi(FD_index,:)').*DY);
        V_equity_vec_H_K(ii)                = sqrt(sum((pars.ppi(FD_index,:)').*DE2) - G_equity_vec_H_K(ii)^2);
        
   end;
   
   if ii>index_last_H
       
          phi_d = phi_d_nr_H(ii)*ones(size(phi));
          k = (e_H(ii)+d_K_H(ii))*ones(size(phi));
          s = 0*ones(size(phi));
          n = net_income(phi,phi_d,phi_d,k,s,pars);
          Profit_rate_vec_H_K(ii) = 1/e_H(ii)*1/numel(phi)*sum(n(n>=0)); 
          DV = NaN(pars.N_z,1);
          DE = NaN(pars.N_z,1);
          DE2 = NaN(pars.N_z,1);
          DK = NaN(pars.N_z,1);
          DY = NaN(pars.N_z,1);
          for jj=1:pars.N_z
            div_issue = (n(n>=e_div(jj)) - e_div(jj))/e_H(ii);
            ep = n; ep(n >=e_div(jj)) = e_div(jj); gep = (ep - e_H(ii))/e_H(ii);
            I = discretize(ep,edges(jj,:));
            kp = k_hat(I,jj); 
            yp = pars.E_phi(jj)*k_hat(I,jj).^(pars.zeta);
            y = (phi.*k(1)).^(pars.zeta);
            gyp = (yp - y)./y;
            gkp = (kp - k(1))/k(1);
            gep(n <= 0) = 0;
            gkp(n <= 0) = 0;
            div_issue(n <= e_div(jj)) = 0;
            gyp(n <= 0) = 0;
            DV(jj) = 1/numel(phi)*sum(div_issue);
            DE(jj) = 1/numel(phi)*sum(gep);
            DE2(jj)= 1/numel(phi)*sum(gep.^2);
            DK(jj)= 1/numel(phi)*sum(gkp);
            DY(jj)= 1/numel(phi)*sum(gyp);
          end;
          Dividend_rate_vec_H_K(ii)                 = sum((pars.ppi(FD_index,:)').*DV);
          G_equity_vec_H_K(ii)                      = sum((pars.ppi(FD_index,:)').*DE);
          G_asset_vec_H_K(ii)                       = sum((pars.ppi(FD_index,:)').*DK);
          G_output_vec_H_K(ii)                      = sum((pars.ppi(FD_index,:)').*DY);
          V_equity_vec_H_K(ii)                      = sqrt(sum((pars.ppi(FD_index,:)').*DE2) - G_equity_vec_H_K(ii)^2);
          
   end;
    
end;
    
FD_moments.Profit_rate_vec_H_R          = Profit_rate_vec_H_R;
FD_moments.Dividend_rate_vec_H_R        = Dividend_rate_vec_H_R;
FD_moments.G_equity_vec_H_R             = G_equity_vec_H_R;
FD_moments.V_equity_vec_H_R             = V_equity_vec_H_R;
FD_moments.G_asset_vec_H_R              = G_asset_vec_H_R;
FD_moments.G_output_vec_H_R             = G_output_vec_H_R;

FD_moments.Profit_rate_vec_H_K          = Profit_rate_vec_H_K;
FD_moments.Dividend_rate_vec_H_K        = Dividend_rate_vec_H_K;
FD_moments.G_equity_vec_H_K             = G_equity_vec_H_K;
FD_moments.V_equity_vec_H_K             = V_equity_vec_H_K;
FD_moments.G_asset_vec_H_K              = G_asset_vec_H_K;
FD_moments.G_output_vec_H_K             = G_output_vec_H_K;
    
end

