function [s,fs,ag,bg,c,d] = golden_section_search( ag, bg, ff, tol )

phi =(sqrt(5)-1)/2;

c = bg - phi*(bg-ag);
d = ag + phi*(bg-ag);

while max(abs(c-d))>tol
    
    fc = ff(c);
    fd = ff(d);
    
    case1 = (fc > fd);
    case2 = (fc <= fd);
    
    if sum(case1) > 0
           
       bg(case1)=d(case1);
       d(case1)=c(case1);
       c(case1)=bg(case1)-phi*(bg(case1)-ag(case1));
       
    end;
            
    if sum(case2) > 0
            
       ag(case2)=c(case2);
       c(case2)=d(case2); 
       d(case2)=ag(case2) + phi*(bg(case2)-ag(case2));
       
    end;
    
end;

s  = (bg+ag)/2;
fs = ff(s);

end

