function [IE,IP] = integral_components(c,d,x,a,b)

numargs = numel(c); IE = NaN(numargs,1); IP = NaN(numargs,1);

case1 = (c >= d);
case2 = (c <  d)&(c <= 0)&(d <= 0);
case3 = (c <  d)&(c <= 0)&(d >  0)&(d < Inf);
case4 = (c <  d)&(c <= 0)&(d == Inf);
case5 = (c <  d)&(c >  0)&(d <  Inf);
case6 = (c <  d)&(c >  0)&(d == Inf);

if ~sum(case1+case2+case3+case4+case5+case6) == numargs
    error('wrong cases in incremental_expectation');
end;

if sum(case1) > 0
    
    IP(case1)       = 0;
    IE(case1)       = 0;
    
end;

if sum(case2) > 0
    
    IP(case2)       = 0;
    IE(case2)       = 0;
    
end;

if sum(case3) > 0
    
    PE = partial_expectation( c(case3) , d(case3) , a(case3) , b(case3) );
    PD = proba_difference( c(case3) , d(case3) , a(case3) , b(case3) );
    
    IP(case3)       = PD;
    IE(case3)       = PE - x(case3).*PD;
    
end;

if sum(case4) > 0
    
    PE = partial_expectation( c(case4) , d(case4) , a(case4) , b(case4) );
    IP(case4)       = 1;
    IE(case4)       = PE - x(case4);
    
end;

if sum(case5) > 0
    
    PE = partial_expectation( c(case5) , d(case5) , a(case5) , b(case5) );
    PD = proba_difference( c(case5) , d(case5) , a(case5) , b(case5) );
    
    IP(case5)       = PD;
    IE(case5)       = PE - x(case5).*PD;
    
end;

if sum(case6) > 0
    
    PE = partial_expectation( c(case6) , d(case6) , a(case6) , b(case6) );
    PD = proba_difference( c(case6) , d(case6) , a(case6) , b(case6) );
    
    IP(case6)       = PD;
    IE(case6)       = PE - x(case6).*PD;
    
end;
    

end

