function [phi_d,phi_b,R,R_b,R_m,PD,PR,LRP,L,dLdphi,dLdk,dphidk,dphids,dphide,dphi_bdk,dphi_bds,dphi_bde] = lending_contract(k,s,e,a,b,z,pars)

numargs = numel(s);

if ( numargs ~= numel(e) || numargs ~= size(a,1) || numargs ~= size(b,1) || numargs ~= numel(s) || numargs ~= numel(k) )
    error('Arguments do not have the same size in borrowing_constraint \n');
end;

phi_d = NaN(numargs,1); R = phi_d; R_b = phi_d; R_m = phi_d; PD = phi_d; PR = phi_d; LRP = phi_d; 
L = phi_d; dLdphi = phi_d; dLdk = phi_d;
dphidk = phi_d; dphide = phi_d; dphids = phi_d; dphi_bdk = phi_d; dphi_bds = phi_d; dphi_bde = phi_d;
phi_b = phi_d;

r_m_r = z(:,end);
case0 = (s == 0);
case1 = ( s >=  1./(1+(1-pars.chi)./(1+r_m_r)*(1+pars.r_b)/pars.chi) )&( s <= 1 );


if sum(case0+case1) ~= numargs
    error('Unexpected cases in lending_contract \n');
end;

if sum(case0) > 0
    [phi_d(case0),PD(case0),R(case0),LRP(case0),L(case0),dLdphi(case0),dLdk(case0),dphidk(case0),dphids(case0),dphide(case0)]   = lending_contract_nr(k(case0),s(case0),e(case0),a(case0),b(case0),z(case0,:),pars);
    dphi_bdk(case0) = NaN;
end;

if sum(case1) > 0
    [phi_d(case1),PD(case1),R_m(case1),LRP(case1),L(case1),dLdphi(case1),dLdk(case1),dphidk(case1),dphids(case1),dphide(case1)] = lending_contract_m(k(case1),s(case1),e(case1),a(case1),b(case1),z(case1,:),pars);
    [phi_b(case1),PR(case1),R_b(case1),~,~,~,dphi_bdk(case1),dphi_bds(case1),dphi_bde(case1)] = lending_contract_b(k(case1),s(case1),e(case1),a(case1),b(case1),pars);
end;

end