function [phi_d,PD,R,LRP,H,dHdphi,dphidk,dphids,dphide] = lending_contract_b(k,s,e,a,b,pars)

nogood = (e < 0 | k < 0); numargs_e = numel(e); numargs_k = numel(k); numargs_a = numel(a); numargs_b = numel(b);

if sum(nogood) > 0
    fprintf('e < 0 or k < 0 in lending_contract_b \n');
end;

if ( numargs_e ~= numargs_k || numargs_e ~= numargs_a || numargs_e ~= numargs_b )
    fprintf('e, k, a and b do not have the same number of elements in lending_contract_b \n');
end;

r_hat_b = (1+pars.r)*s/pars.chi - 1;
r_tilde_b = (1+pars.r_b)*s/pars.chi - 1;
E_phi = a.*gamma(1+1./b);

case0 = ( e > 0 )&( k > 0 )&( k < e );
case1 = ( r_tilde_b + pars.delta_k > 0  )&( ( e > 0 )&( k >= e  )&( k < (1+r_tilde_b)./(pars.delta_k+r_tilde_b).*e ) );
case2 = ( r_tilde_b + pars.delta_k > 0  )&( ( ( e > 0 )&( k >= ((1+r_tilde_b)./(pars.delta_k+r_tilde_b).*e) ) ) | ( e == 0 )&( k > 0) );
case3 = ( r_tilde_b + pars.delta_k <= 0 )&( ( ( e > 0 )&( k >= e  ) | ( e == 0 )&( k > 0 ) ) );

phi_d = NaN(numargs_e,1); H = phi_d;
dHdphi = phi_d; dphidk = phi_d; dphide = phi_d; dphids = phi_d;

if sum(case0) > 0
    
    phi_d(case0) = (r_hat_b(case0)+pars.delta_k).*(k(case0).^(-pars.zeta)).*(k(case0) - (1+r_hat_b(case0))./(pars.delta_k+r_hat_b(case0)).*e(case0));
    H(case0)     = phi_d(case0);
    dHdphi(case0) = 1;
    
    dphidk(case0) = (r_hat_b(case0)+pars.delta_k).*(-pars.zeta*(k(case0).^(-pars.zeta-1)).*(k(case0) - (1+r_hat_b(case0))./(pars.delta_k+r_hat_b(case0)).*e(case0)) + k(case0).^(-pars.zeta) );
    dphids(case0) = (1+pars.r)./pars.chi*k(case0).^(-pars.zeta).*(k(case0) - e(case0));
    dphide(case0) = -(1+r_hat_b(case0)).*(k(case0).^(-pars.zeta));
    
end;

if sum(case1) > 0
    
    phi_d(case1) = (r_tilde_b(case1)+pars.delta_k).*(k(case1).^(-pars.zeta)).*(k(case1) - (1+r_tilde_b(case1))./(pars.delta_k+r_tilde_b(case1)).*e(case1));
    H(case1)     = phi_d(case1);
    dHdphi(case1) = 1;
    
    dphidk(case1) = (r_tilde_b(case1)+pars.delta_k).*(-pars.zeta*(k(case1).^(-pars.zeta-1)).*(k(case1) - (1+r_tilde_b(case1))./(pars.delta_k+r_tilde_b(case1)).*e(case1)) + k(case1).^(-pars.zeta) );
    dphids(case1) = (1+pars.r_b)./pars.chi*k(case1).^(-pars.zeta).*(k(case1) - e(case1));
    dphide(case1) = -(1+r_tilde_b(case1)).*(k(case1).^(-pars.zeta));
    
end;

if sum(case2) > 0
    
    case21 = case2&( abs( E_phi - k.^(-pars.zeta).*(pars.delta_k+r_tilde_b).*(k - (1+r_tilde_b)./(pars.delta_k+r_tilde_b).*e) ) < pars.tol_f_contr);
    if sum(case21) > 0
        %phi_d(case21) = Inf;
        %phi_d(case21) = icdf(pars.FF{end},1-pars.tol_x_contr);
        phi_d(case21) = a(case21).*(-log(pars.tol_x_contr)).^(1./b(case21));
    end;
    
    case22 = case2&(~case21);
    if sum(case22) > 0
        phi_d_low  = zeros(sum(case22),1);
        phi_d_high = icdf(pars.FF{end},1-pars.tol_x_contr)*ones(sum(case22),1);
        k2 = k(case22); e2 = e(case22); a2 = a(case22); b2 = b(case22); r_tilde_b2 = r_tilde_b(case22);
        ff = @(x,indexes) H_fun(x,a2(indexes),b2(indexes)) - (k2(indexes).^(-pars.zeta)).*(pars.delta_k+r_tilde_b2(indexes)).*(k2(indexes) - (1+r_tilde_b2(indexes))./(pars.delta_k+r_tilde_b2(indexes)).*e2(indexes));
        x_low = phi_d_low; x_high = phi_d_high; tol_f = pars.tol_f_contr; tol_x = pars.tol_x_contr;
        return_warning{1} = true; return_warning{2} = 'lending_contract_b';
        phi_d(case22) = bissection(x_low,x_high,ff,tol_f,tol_x,return_warning);
    end;
    
    H(case2)  = H_fun(phi_d(case2),a(case2),b(case2));
    F2 = 1 - exp( -( (phi_d(case2)./a(case2)).^(b(case2)) ) );
    dHdphi(case2) = 1 - F2;
    
    dphidk(case2) = ( (r_tilde_b(case2)+pars.delta_k).*( -pars.zeta*(k(case2).^(-pars.zeta-1)).*(k(case2) - (1+r_tilde_b(case2))./(pars.delta_k+r_tilde_b(case2)).*e(case2)) + k(case2).^(-pars.zeta) ) )./( dHdphi(case2) );
    
    dphids(case2) = (1+pars.r_b)./pars.chi*k(case2).^(-pars.zeta).*(k(case2) - e(case2)).*1./(dHdphi(case2));
    dphide(case2) = -(1+r_tilde_b(case2)).*(k(case2).^(-pars.zeta))./( dHdphi(case2) );
    
end;

if sum(case3) > 0
    
    phi_d(case3)  = (r_tilde_b(case3)+pars.delta_k).*(k(case3).^(-pars.zeta)).*(k(case3) - (1+r_tilde_b(case3))./(pars.delta_k+r_tilde_b(case3)).*e(case3));
    H(case3)      = phi_d(case3);
    dHdphi(case3) = 1;
    
    dphidk(case3) = (r_tilde_b(case3)+pars.delta_k).*(-pars.zeta*(k(case3).^(-pars.zeta-1)).*(k(case3) - (1+r_tilde_b(case3))./(pars.delta_k+r_tilde_b(case3)).*e(case3)) + k(case3).^(-pars.zeta) );    
    dphids(case3) = (1+pars.r_b)./pars.chi*k(case3).^(-pars.zeta).*(k(case3) - e(case3));
    dphide(case3) = -(1+r_tilde_b(case3)).*(k(case3).^(-pars.zeta));
    
end;

% Extensions at k=0
phi_d( k == 0 & e > 0 ) = -Inf;
phi_d( k == 0 & e == 0 )= 0;
H( k == 0 & e > 0 ) = -Inf;
H( k == 0 & e == 0 )= 0;
dHdphi(k == 0) = 1;
dphidk((k == 0)&( r_hat_b + pars.delta_k > 0))  = Inf;
dphidk((k == 0)&( r_hat_b + pars.delta_k <= 0)) = -Inf;
dphide(k == 0) = -Inf;

% Other output
R = pars.chi*(phi_d.*(k.^(pars.zeta)) + (1-pars.delta_k)*k); R(k==0) = -(1+pars.r).*s(k==0).*e(k==0);
PD = 1 - exp( -( (phi_d./a).^(b) ) ); PD(phi_d <= 0) = 0;
LRP = (k.^(pars.zeta)).*( phi_d -  H )./(k-e); LRP(k <= (1+r_tilde_b)./(pars.delta_k+r_tilde_b).*e ) = 0;

end