function [phi_d,PD,R,LRP,L,dLdphi,dLdk,dphidk,dphids,dphide,M,dMdphi,dMdk,H,dHdphi] = lending_contract_nr(k,s,e,a,b,z,pars)

nogood = (e < 0 | k < 0); numargs_e = numel(e); numargs_k = numel(k); numargs_a = numel(a); numargs_b = numel(b);

if sum(nogood) > 0
    fprintf('e < 0 or k < 0 in lending_contract \n');
end;

if ( numargs_e ~= numargs_k || numargs_e ~= numargs_a || numargs_e ~= numargs_b )
    fprintf('e, k, a and b do not have the same number of elements in lending_contract \n');
end;

r_m = z(:,(end-1));
chi_m = z(:,(end-2));
r_tilde_s = (1+pars.r_b)*s + (1+r_m).*(1-s) - 1;
delta_tilde = 1-pars.chi_L*(1-pars.delta_k);
delta_hat   = 1-((pars.chi_L - chi_m)./(1-chi_m)).*(1-delta_tilde);

case0 = ( k > 0)&( k <= e );
case1 = ( k > e)&( k <= (1+r_tilde_s)./(delta_tilde+r_tilde_s).*e );
case2 = ( k > (1+r_tilde_s)./(delta_tilde+r_tilde_s).*e );

phi_d = NaN(numargs_e,1); H = phi_d; L = phi_d; 
dLdphi = phi_d; dHdphi = phi_d; dLdk = phi_d; dphidk = phi_d; dphide = phi_d; dphids = phi_d;

if sum(case0) > 0
    
    phi_d(case0) = (pars.r+delta_tilde)*(k(case0).^(-pars.zeta)).*(k(case0) - (1+pars.r)/(delta_tilde+pars.r)*e(case0));
    H(case0)     = phi_d(case0);
    L(case0)     = 0;

    dLdphi(case0) = 0;
    dHdphi(case0) = 1;
    dLdk(case0)   = 0;
    
    dphidk(case0) = (pars.r+delta_tilde)*(-pars.zeta*(k(case0).^(-pars.zeta-1)).*(k(case0) - (1+pars.r)/(delta_tilde+pars.r)*e(case0)) + k(case0).^(-pars.zeta) );
    dphids(case0) = (1+pars.r)*k(case0).^(-pars.zeta).*(k(case0) - e(case0));
    dphide(case0) = -(1+pars.r)*(k(case0).^(-pars.zeta));
    
end;

if sum(case1) > 0
    
    phi_d(case1) = (r_tilde_s(case1) +delta_tilde).*(k(case1).^(-pars.zeta)).*(k(case1) - (1+r_tilde_s(case1) )./(delta_tilde+r_tilde_s(case1) ).*e(case1));
    
    H(case1)     = phi_d(case1);
    L(case1)     = 0;

    dLdphi(case1) = 0;
    dHdphi(case1) = 1;
    dLdk(case1)   = 0;
    
    dphidk(case1) = (r_tilde_s(case1) +delta_tilde).*(-pars.zeta*(k(case1).^(-pars.zeta-1)).*(k(case1) - (1+r_tilde_s(case1) )./(delta_tilde+r_tilde_s(case1) ).*e(case1)) + k(case1).^(-pars.zeta) );
    dphids(case1) = (pars.r_b - r_m(case1)).*k(case1).^(-pars.zeta).*(k(case1) - e(case1));
    dphide(case1) = -(1+r_tilde_s(case1) ).*(k(case1).^(-pars.zeta));
    
end;

if sum(case2) > 0
    
    phi_d_low  = zeros(sum(case2),1);
    phi_d_high = maximum_default_nr(k(case2),a(case2),b(case2),z(case2,:),pars);
    k2 = k(case2); e2 = e(case2); a2 = a(case2); b2 = b(case2); r_tilde_s2 = r_tilde_s(case2); z2 = z(case2,:); delta_hat2 = delta_hat(case2,:);
    ff = @(x,indexes) (k2(indexes).^(pars.zeta)).*M_fun(x,-(1-delta_hat2(indexes)).*(k2(indexes).^(1-pars.zeta)),a2(indexes),b2(indexes),z2(indexes,:),pars) - (delta_tilde+r_tilde_s2(indexes)).*(k2(indexes) - (1+r_tilde_s2(indexes))./(delta_tilde+r_tilde_s2(indexes)).*e2(indexes));
    x_low = phi_d_low; x_high = phi_d_high; tol_f = pars.tol_f_contr; tol_x = pars.tol_x_contr;
    return_warning{1} = true; return_warning{2} = 'lending_contract';
    phi_d(case2) = bissection(x_low,x_high,ff,tol_f,tol_x,return_warning);
    
    H(case2)  = H_fun(phi_d(case2),a(case2),b(case2));
    L(case2)  = L_fun(phi_d(case2),k(case2),a(case2),b(case2),pars);
    
    f2 =  (b(case2)./a(case2)).*(phi_d(case2)./a(case2)).^(b(case2)-1).*exp( -( (phi_d(case2)./a(case2)).^(b(case2)) ) );
    F2 = 1 - exp( -( (phi_d(case2)./a(case2)).^(b(case2)) ) );
    
    dLdphi(case2) = f2.*( phi_d(case2) + (1-delta_hat(case2)).*(k(case2).^(1-pars.zeta)) );
    dHdphi(case2) = 1 - F2;
    dLdk(case2)   = (1-delta_hat(case2)).*(1-pars.zeta).*(k(case2).^(-pars.zeta)).*F2;
    
    dphidk(case2) = ( (r_tilde_s(case2)+delta_tilde).*( -pars.zeta*(k(case2).^(-pars.zeta-1)).*(k(case2) - (1+r_tilde_s(case2))./(delta_tilde+r_tilde_s(case2)).*e(case2)) + k(case2).^(-pars.zeta) ) + (1-chi_m(case2)).*dLdk(case2) )./( max(0, dHdphi(case2) - (1-chi_m(case2)).*dLdphi(case2) ) );
    dphids(case2) = 1./max(0, dHdphi(case2) - (1-chi_m(case2)).*dLdphi(case2) ).*( (pars.r_b - r_m(case2)).*k(case2).^(-pars.zeta).*(k(case2) - e(case2)) );
    dphide(case2) = -(1+r_tilde_s(case2)).*(k(case2).^(-pars.zeta))./( max(0, dHdphi(case2) - (1-chi_m(case2)).*dLdphi(case2) ) );
    
end;

% Extensions at k=0
phi_d( k == 0 & e > 0 ) = -Inf;
phi_d( k == 0 & e == 0 )= 0;
H( k == 0 & e > 0 ) = -Inf;
H( k == 0 & e == 0 )= 0;
L( k == 0 ) = 0;
dHdphi(k == 0 ) = 1;
dLdphi(k == 0 ) = 0;
dLdk(k == 0 & e > 0 ) = 0;
dLdk(k == 0 & e == 0 & ((b+1)*pars.zeta <= 1 ) ) = 0;
dLdk(k == 0 & e == 0 & ((b+1)*pars.zeta > 1 ) ) = Inf;
dphidk(k == 0) = Inf;
dphide(k == 0) = -Inf;
dphids(k == 0) = 0;

% Other output
R = phi_d.*(k.^(pars.zeta)) + (1-delta_tilde).*k; R(k==0) = -(1+pars.r)*e(k==0);
PD = 1 - exp( -( (phi_d./a).^(b) ) ); PD(phi_d <= 0) = 0;
M = H - (1-chi_m).*L;
LRP = (k.^(pars.zeta)).*( phi_d -  M )./(k-e); LRP(k <= (1+r_tilde_s)./(delta_tilde+r_tilde_s).*e ) = 0;
dMdphi = max(0,dHdphi - (1-chi_m).*dLdphi);
dMdk = -(1-chi_m).*dLdk;

end