function out = matching_target(x,policy_functions,A,B,ecv,steady_state,current_mu,next_e,pars,print_stuff)

if pars.paralellized_inside
    [BS,Mixed_Frac,ag_lev,nw_entry_ratio] = aggregate_implications_for_moment_matching_paralellized(x,policy_functions,A,B,ecv,steady_state,current_mu,next_e,pars,false);
else
    [BS,Mixed_Frac,ag_lev,nw_entry_ratio] = aggregate_implications_for_moment_matching(x,policy_functions,A,B,ecv,steady_state,current_mu,next_e,pars,false);
end;
out = (8/10)*(100*BS/24 - 1)^2 + (1/10)*(100*ag_lev/56 - 1)^2 + (1/10)*(100*Mixed_Frac/60 - 1)^2;

if print_stuff
    fprintf('   Bank share                              = %7.4f \n',BS);
    fprintf('   Fraction mixed-debt firms               = %7.4f \n',Mixed_Frac);
    fprintf('   Liabilities to assets                   = %7.4f \n',ag_lev);
    fprintf('   Fraction of net worth to entrants       = %7.4f \n',nw_entry_ratio);
end;

end