function [k_min,dk_minds,dk_minde] = minimum_borrowing(s,e,z,pars)

r_tilde_b   = (1+pars.r_b)*s/pars.chi - 1;
k_min       = ( (1+pars.r_b)*s/pars.chi )./( (1+pars.r_b)*s/pars.chi - (1-pars.delta_k) ).*e;
dk_minds    = -(1+pars.r_b)/pars.chi*(k_min - e).*(1./( r_tilde_b + pars.delta_k )); 
dk_minde    = (1+r_tilde_b)./(pars.delta_k+r_tilde_b); 

%Useful values
r_m = z(:,end);
chi_m = z(:,(end-2));
s_r_tilde = 1./(1+(pars.chi_L-chi_m)./(1+r_m)*(1+pars.r_b)./chi_m);

case1 = ( s < s_r_tilde );

if sum(case1) > 0
    
    [k_min(case1),dk_minds(case1),dk_minde(case1)] = borrowing_constraint_f_min(s(case1),e(case1),z(case1,:),pars);
    
end;

end

