function n = net_income(phi,phi_d,phi_b,k,s,pars)

numargs = numel(phi);

case1 = ( s == 0 );
case2 = ( s > 0 )&( phi <= phi_b );
case3 = ( s > 0 )&( phi > phi_b );

if sum(case1+case2+case3) ~= numargs
    error('wrong number of elements in net_income \n');
end;

n = NaN(numargs,1);

if sum(case1) > 0
    n(case1) = (phi(case1)-phi_d(case1)).*(k(case1).^(pars.zeta)) + (1-pars.chi_L)*(1-pars.delta_k)*k(case1);
end;

if sum(case2) > 0
    n(case2) = (1-pars.chi)*(phi(case2)-phi_d(case2)).*(k(case2).^(pars.zeta)) + (1-pars.chi_L)*(1-pars.delta_k)*k(case2) ;
end;

if sum(case3) > 0
    n(case3) = (phi(case3)-(1-pars.chi)*phi_d(case3) - pars.chi*phi_b(case3)).*(k(case3).^(pars.zeta)) + (1-pars.delta_k)*(1-pars.chi_L)*k(case3);
end;

end

