function [out,doutdx,doutdy] = partial_expectation( x , y , a , b )

numargs = numel(x); out = NaN(numargs,1); doutdx = out; doutdy = out;

nogood = (x > y);

if sum(nogood) > 0
    error('x < y in partial_expectation \n');
end;

case1 = (x >  0 & y > 0);
case2 = (x <= 0 & y > 0);
case3 = (x <= 0 & y <= 0);

if sum(case1+case2+case3) ~= numargs
    error('some cases not treated in partial_expectation \n');
end;

if sum(case1) > 0
    out(case1)    = a(case1).*gammainc((y(case1)./a(case1)).^(b(case1)),(b(case1)+1)./b(case1)).*gamma((b(case1)+1)./b(case1)) -  a(case1).*gammainc((x(case1)./a(case1)).^(b(case1)),(b(case1)+1)./b(case1)).*gamma((b(case1)+1)./b(case1));
    doutdx(case1) = -(b(case1)./a(case1)).*((x(case1)./a(case1)).^(b(case1)-1)).*exp( -(x(case1)./a(case1)).^(b(case1)) ).*x(case1);
    doutdy(case1) = (b(case1)./a(case1)).*((y(case1)./a(case1)).^(b(case1)-1)).*exp( -(y(case1)./a(case1)).^(b(case1)) ).*y(case1);
end;

if sum(case2) > 0
    out(case2)    = a(case2).*gammainc((y(case2)./a(case2)).^(b(case2)),(b(case2)+1)./b(case2)).*gamma((b(case2)+1)./b(case2)); 
    doutdx(case2) = 0;
    doutdy(case2) = (b(case2)./a(case2)).*((y(case2)./a(case2)).^(b(case2)-1)).*exp( -(y(case2)./a(case2)).^(b(case2)) ).*y(case2);
end;

if sum(case3) > 0
    out(case3)    = 0; 
    doutdx(case3) = 0;
    doutdy(case3) = 0;
end;

doutdx(x==Inf|x==-Inf) = 0;
doutdy(y==Inf|y==-Inf) = 0;

end

