function fig7(policy_functions,pars,figname,savepath,fignum,has_arrows)

graphname           = strcat(savepath,'/',figname);
f1                  = figure(fignum);

e                   = policy_functions.e;
s_hat_r             = policy_functions.s_hat_r;
k_hat_r             = policy_functions.k_hat_r;
k_hat_nr            = policy_functions.k_hat_nr;

FD_index = 2;
FD_moments = computing_FD_moments_alt( FD_index, policy_functions, pars );
%FD_moments = computing_FD_moments( FD_index, policy_functions, pars );

e_H = e(:,FD_index); nn_e = size(e,1);
s_R_H = s_hat_r(:,FD_index);
d_R_H = k_hat_r(:,FD_index) - e_H;
d_K_H = k_hat_nr(:,FD_index) - e_H;
index_last_H = sum(~isnan(s_R_H));

Profit_rate_vec_H_R          = FD_moments.Profit_rate_vec_H_R;
Dividend_rate_vec_H_R        = FD_moments.Dividend_rate_vec_H_R;
G_equity_vec_H_R             = FD_moments.G_equity_vec_H_R;
V_equity_vec_H_R             = FD_moments.V_equity_vec_H_R;

Profit_rate_vec_H_K          = FD_moments.Profit_rate_vec_H_K;
Dividend_rate_vec_H_K        = FD_moments.Dividend_rate_vec_H_K;
G_equity_vec_H_K             = FD_moments.G_equity_vec_H_K;
V_equity_vec_H_K             = FD_moments.V_equity_vec_H_K;

ffont = 'Palatino';
fontsize = 8;
widthline = 2;

xhigh = e_H(end);

subplot(141)
plot(e_H(1:index_last_H),100*e_H(1:index_last_H)./(e_H(1:index_last_H)+d_R_H(1:index_last_H)),'LineWidth',widthline,'Color','black');
hold on;
plot(e_H((index_last_H):end),100*e_H(index_last_H:end)./(e_H(index_last_H:end)+d_K_H(index_last_H:end)),'LineWidth',widthline,'Color','black');
hold on;
plot(e_H,zeros(nn_e,1),'LineWidth',widthline-1.5,'Color','black');
plot(e_H(index_last_H),100*e_H(index_last_H)./(e_H(index_last_H)+d_R_H(index_last_H)),'-k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',3.5);
hold on;
plot(e_H((index_last_H)),100*e_H(index_last_H)./(e_H(index_last_H)+d_K_H(index_last_H)),'-k','Marker','o','MarkerEdgeColor','k','MarkerSize',3.5);
ylim([-5 60]);
xlim([0 xhigh]);
yl = get(gca,'ylim');
plot(e_H(index_last_H)*ones(nn_e,1),linspace(yl(1),yl(2),nn_e),'--','LineWidth',0.5,'Color','black');
ylabel('$\%$','FontSize',fontsize,'FontWeight','Bold','Interpreter','Latex','Rotation',0);
xlabel('Internal finance ($e_t$)','FontSize',fontsize-1,'FontWeight','Bold','Interpreter','Latex');
title({'\makebox[4in][c]{Internal finance to assets}'},'FontSize',fontsize,'fontname',ffont,'rotation',0,'Interpreter','Latex');
set(gca,'fontsize',fontsize-2,'fontname','Palatino','TickLabelInterpreter', 'latex');

if has_arrows

    textar1 = text(e_H(index_last_H)*1.1,30,'Hello');
    set(textar1,...
        'String',{'   $e^{*}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex');

end;

subplot(142)
h1 = plot(e_H(1:index_last_H),100*(Profit_rate_vec_H_R(1:index_last_H)-1),'LineWidth',widthline,'Color','black');
hold on;
plot(e_H((index_last_H):end),100*(Profit_rate_vec_H_K((index_last_H):end)-1),'LineWidth',widthline,'Color','black');
hold on;
h2 = plot(e_H(1:index_last_H),100*(Dividend_rate_vec_H_R(1:index_last_H)),'--','LineWidth',widthline,'Color','black');
hold on;
plot(e_H((index_last_H):end),100*(Dividend_rate_vec_H_K((index_last_H):end)),'--','LineWidth',widthline,'Color','black');
hold on;
plot(e_H,zeros(nn_e,1),'LineWidth',widthline-1.5,'Color','black');
plot(e_H(index_last_H),100*(Profit_rate_vec_H_R(index_last_H)),'-k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',3.5);
hold on;
plot(e_H((index_last_H)),100*(Profit_rate_vec_H_K((index_last_H))),'-k','Marker','o','MarkerEdgeColor','k','MarkerSize',3.5);
hold on;
plot(e_H(index_last_H),100*(Dividend_rate_vec_H_R(index_last_H)),'-k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',3.5);
hold on;
plot(e_H((index_last_H)),100*(Dividend_rate_vec_H_K((index_last_H))),'-k','Marker','o','MarkerEdgeColor','k','MarkerSize',3.5);
%ylim([-1.5 60]);
ylim([-1.5 20]);
yl = get(gca,'ylim');
plot(e_H(index_last_H)*ones(nn_e,1),linspace(yl(1),yl(2),nn_e),'--','LineWidth',0.5,'Color','black');
xlabel('Internal finance ($e_t$)','FontSize',fontsize-2,'FontWeight','Bold','Interpreter','Latex');
ylabel('$\%$','FontSize',fontsize,'FontWeight','Bold','Interpreter','Latex','Rotation',0);
title({'\makebox[4in][c]{Average rate of profits}','\makebox[4in][c]{and dividend issuance}'},'FontSize',fontsize,'fontname',ffont,'rotation',0,'Interpreter','Latex');
ll = legend([h1,h2],'Profits','Dividends');
set(ll,'fontsize',fontsize - 2,'fontname','Palatino','Interpreter','Latex');
set(gca,'Fontsize',fontsize- 2,'fontname',ffont,'TickLabelInterpreter', 'latex');
xlim([0 xhigh]);

if has_arrows

    textar1 = text(e_H(index_last_H)*1.1,10,'Hello');
    set(textar1,...
    'String',{'   $e^{*}(z)$ '},...
    'FontSize',fontsize,...
    'FontName',ffont,...
    'Interpreter','Latex');

end;

subplot(143)
plot(e_H(1:index_last_H),100*(G_equity_vec_H_R(1:index_last_H)),'LineWidth',widthline,'Color','black');
hold on;
plot(e_H((index_last_H):end),100*(G_equity_vec_H_K((index_last_H):end)),'LineWidth',widthline,'Color','black');
hold on;
plot(e_H,zeros(nn_e,1),'LineWidth',widthline-1.5,'Color','black');
plot(e_H(index_last_H),100*(G_equity_vec_H_R(index_last_H)),'-k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',3.5);
hold on;
plot(e_H((index_last_H)),100*(G_equity_vec_H_K((index_last_H))),'-k','Marker','o','MarkerEdgeColor','k','MarkerSize',3.5);
xlabel('Internal finance ($e_t$)','FontSize',fontsize-1,'FontWeight','Bold','Interpreter','Latex');
ylabel('$\%$','FontSize',fontsize,'FontWeight','Bold','Interpreter','Latex','Rotation',0);
title({'\makebox[4in][c]{Average growth rate of}','\makebox[4in][c]{internal finance}'},'FontSize',fontsize,'fontname',ffont,'rotation',0,'Interpreter','Latex');
set(gca,'fontsize',fontsize-2,'fontname',ffont,'TickLabelInterpreter', 'latex');
xlim([0 xhigh]);
ylim([-1.5 20]);
yl = get(gca,'ylim');
plot(e_H(index_last_H)*ones(nn_e,1),linspace(yl(1),yl(2),nn_e),'--','LineWidth',0.5,'Color','black');

if has_arrows

    textar1 = text(e_H(index_last_H)*1.1,10,'Hello');
    set(textar1,...
        'String',{'   $e^{*}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex');

    %{
    [arrowx,arrowy] = dsxy2figxy(gca, [6-0.7 6-0.2],[2 2]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'   $\bar{e}(z)$ '},...
        'FontSize',fontsize-2,...
        'FontName',ffont,...
        'Interpreter','Latex',...
        'HeadWidth',2,...
        'HeadLength',2);
    %}    

end;

subplot(144)
offset = 0;
plot(e_H(1:index_last_H),100*(V_equity_vec_H_R(1:index_last_H)),'LineWidth',widthline,'Color','black');
hold on;
plot(e_H((index_last_H):end),100*(V_equity_vec_H_K((index_last_H):end))-offset,'LineWidth',widthline,'Color','black');
hold on;
plot(e_H,zeros(nn_e,1),'LineWidth',widthline-1.5,'Color','black');
plot(e_H(index_last_H),100*(V_equity_vec_H_R(index_last_H)),'-k','Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',3.5);
hold on;
plot(e_H((index_last_H)),100*(V_equity_vec_H_K((index_last_H)))-offset,'-k','Marker','o','MarkerEdgeColor','k','MarkerSize',3.5);
xlabel('Internal finance ($e_t$)','FontSize',fontsize-1,'FontWeight','Bold','Interpreter','Latex');
ylabel('$\%$','FontSize',fontsize,'FontWeight','Bold','Interpreter','Latex','Rotation',0);
title({'\makebox[4in][c]{Standard deviation of}','\makebox[4in][c]{growth rate of internal finance}'},'FontSize',fontsize,'fontname',ffont,'rotation',0,'Interpreter','Latex');
set(gca,'fontsize',fontsize-2,'fontname',ffont,'TickLabelInterpreter', 'latex');
xlim([0 xhigh]);
%ylim([-1.5 25]);
yl = get(gca,'ylim');
plot(e_H(index_last_H)*ones(nn_e,1),linspace(yl(1),yl(2),nn_e),'--','LineWidth',0.5,'Color','black');

if has_arrows

    textar1 = text(e_H(index_last_H)*1.1,3.1,'Hello');
    set(textar1,...
        'String',{'   $e^{*}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex');

    %{
    [arrowx,arrowy] = dsxy2figxy(gca, [6-0.7 6-0.2],[2 2]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'   $\bar{e}(z)$ '},...
        'FontSize',fontsize-2,...
        'FontName',ffont,...
        'Interpreter','Latex',...
        'HeadWidth',2,...
        'HeadLength',2);
    %}    

end;

set(f1, 'PaperUnits', 'inches') 
set(f1, 'PaperOrientation', 'portrait');
set(f1, 'PaperSize',[8.5 2.75]);
papersize = get(gcf,'PaperSize');
width  = 8.5;         
height = 2.75;          
bottom = (papersize(2)- height)/2;
left = (papersize(1)- width)/2;
myfiguresize = [left, bottom, width, height];
set(gcf, 'PaperPosition', myfiguresize);
print(f1, '-depsc2',  graphname); 
