function fig8(policy_functions,policy_functions_baseline,pars,figname,savepath,fignum,has_arrows)

graphname           = strcat(savepath,'/',figname);

z_to_plot           = 3;
e_bas               = policy_functions_baseline.e(:,z_to_plot);
k_r_bas             = policy_functions_baseline.k_hat_r(:,z_to_plot);
index_r_bas         = ~isnan(k_r_bas);
k_nr_bas            = policy_functions_baseline.k_hat_nr(:,z_to_plot);
index_nr_bas        = ~isnan(k_nr_bas);
index_switch_bas    = find(~isnan(k_r_bas),1,'last');
s_hat_r_bas         = policy_functions_baseline.s_hat_r(:,z_to_plot);

z_to_plot           = 3;
e                   = policy_functions.e(:,z_to_plot);
k_r                 = policy_functions.k_hat_r(:,z_to_plot);
index_r             = ~isnan(k_r);
k_nr                = policy_functions.k_hat_nr(:,z_to_plot);
index_switch        = find(~isnan(k_r),1,'last');
index_nr            = (~isnan(k_nr));
s_hat_r             = policy_functions.s_hat_r(:,z_to_plot);

% Make graph
f1                      = figure(fignum);
lw                      = 3;
grey                    = [0.6;0.6;0.6];
fontsize                = 13; 
ffont                   = 'Palatino';
colour                  = '-k';

subplot(121)
plot(e_bas(index_r_bas),k_r_bas(index_r_bas),'-k','LineWidth',lw);
hold on;
plot(e(index_r),k_r(index_r),'-k','LineWidth',lw,'Color',[0.6;0.6;0.6]);
hold on;
plot(e_bas(index_nr_bas),k_nr_bas(index_nr_bas),'Color','black','LineWidth',lw);
hold on;
plot(e_bas(index_switch_bas)*ones(50,1),linspace(0,80,50),'--','Color','black','LineWidth',lw-1);
hold on;
plot(e(index_switch)*ones(50,1),linspace(0,80,50),'--','Color',grey,'LineWidth',lw-1);
hold on;
plot(e(1)*ones(50,1),linspace(0,80,50),'--','Color',grey,'LineWidth',lw-1);
hold on;
plot(e_bas(index_switch_bas),k_r_bas(index_switch_bas),'Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',6);
hold on;
plot(e_bas(index_switch_bas),k_nr_bas(index_switch_bas),colour,'Marker','o','MarkerEdgeColor','k','MarkerSize',6);
hold on;
plot(e(index_switch),k_r(index_switch),'Color',grey,'Marker','o','MarkerEdgeColor',grey,'MarkerFaceColor',grey,'MarkerSize',6);
hold on;
plot(e(index_switch),k_nr(index_switch),'Color',grey,'Marker','o','MarkerEdgeColor',grey,'MarkerSize',6);
hold on;
plot(e_bas(end)*ones(50,1),linspace(0,80,50),'--','Color','black','LineWidth',lw-1);
hold on;
plot(e(index_nr),k_nr(index_nr),'Color',[0.6;0.6;0.6],'LineWidth',lw);
hold on;
plot(e(end)*ones(50,1),linspace(0,80,50),'--','Color',grey,'LineWidth',lw-1);
hold on;
plot(e(index_switch)*ones(50,1),linspace(0,80,50),'--','Color',[0.6;0.6;0.6],'LineWidth',lw-1);
ylim([0 20]);
xlim([0 8]);
ll = legend('Baseline','Interim equity issuance');
set(ll,'location','NorthWest','Interpreter','Latex');
xlabel('Internal finance $e_t$','FontSize',13,'FontWeight','Bold','Interpreter','Latex');
title('Total assets $\hat{k}(e_t,z_H) = e_t + \hat{b}(e_t,z_H) + \hat{m}(e_t,z_H)$','Fontsize',13,'fontname','Palatino','Interpreter','Latex')
set(gca,'Fontsize',11,'fontname','Palatino','TickLabelInterpreter', 'latex');

if has_arrows 

    textar1 = text(0.5*e(1),8,'Hello');
    set(textar1,...
        'String',{'   $\underline{e}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex',...
        'color',grey);
    
    textar1 = text(1.1*e(index_switch),4,'Hello');
    set(textar1,...
        'String',{'   $e^{*}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex',...
        'color',grey);
    
    %{
    [arrowx,arrowy] = dsxy2figxy(gca, [e(1)+0.25 e(1)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$\underline{e}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color',grey);

    [arrowx,arrowy] = dsxy2figxy(gca, [e_bas(index_switch_bas)+0.25 e_bas(index_switch_bas)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$e^{*}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color','black');

    [arrowx,arrowy] = dsxy2figxy(gca, [e(index_switch)-0.25 e(index_switch)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$e^{*}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color',grey);

    [arrowx,arrowy] = dsxy2figxy(gca, [e(end)-0.25 e(end)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$\bar{e}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color',grey);

    [arrowx,arrowy] = dsxy2figxy(gca, [e_bas(end)+0.25 e_bas(end)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$\bar{e}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color','black');
    %}
    

end;

nn_e = size(e_bas,1);

subplot(122)

h1 = plot(e_bas(1:index_switch_bas),100*s_hat_r_bas(1:index_switch_bas)+0.25,colour,'LineWidth',2);
hold on;
plot(e_bas(index_switch_bas),100*s_hat_r_bas(index_switch_bas)+0.25,colour,'Marker','o','MarkerEdgeColor','k','MarkerFaceColor','k','MarkerSize',6);
hold on;
plot(e_bas(index_switch_bas:end),0*e_bas(index_switch_bas:end)+0.25,colour,'LineWidth',2);
hold on;
plot(e_bas(index_switch_bas),0*s_hat_r_bas(index_switch_bas)+0.25,colour,'Marker','o','MarkerEdgeColor','k','MarkerSize',6);
hold on;
plot(e_bas(index_switch_bas)*ones(nn_e,1),linspace(0,100,nn_e),'--','LineWidth',2,'Color','black');
hold on;

h2 = plot(e(1:index_switch),100*s_hat_r(1:index_switch)+0.25,'LineWidth',2,'Color',grey);
hold on;
plot(e(index_switch),100*s_hat_r(index_switch)+0.25,'Color',grey,'Marker','o','MarkerEdgeColor',grey,'MarkerFaceColor',grey,'MarkerSize',6);
hold on;
plot(e(index_switch:end),0*e(index_switch:end)+0.25,'Color',grey,'LineWidth',2);
hold on;
plot(e(index_switch),0*s_hat_r(index_switch)+0.25,'Color',grey,'Marker','o','MarkerEdgeColor',grey,'MarkerSize',6);
hold on;
plot(e(index_switch)*ones(nn_e,1),linspace(0,100,nn_e),'--','LineWidth',2,'Color',grey);
hold on;
plot(e(1)*ones(50,1),linspace(0,80,50),'--','Color',grey,'LineWidth',lw-1);
hold on;
plot(e(end)*ones(nn_e,1),linspace(0,100,nn_e),'--','LineWidth',2,'Color',grey);

ylim([0 80])
xlim([0 8])
xlabel('Internal finance ($e_t$)','FontSize',fontsize,'FontWeight','Bold','Interpreter','Latex');
ylabel('$\% \quad \quad \quad$',...
       'FontSize',fontsize,'FontWeight','Bold','Interpreter','Latex','Rotation',00);
set(gca,'fontsize',fontsize - 2,'fontname',ffont);

ll = legend([h1 h2],'Baseline','Interim equity issuance');
set(ll,'location','NorthWest','Interpreter','Latex');
xlabel('Internal finance $e_t$','FontSize',13,'FontWeight','Bold','Interpreter','Latex');
title('Optimal bank share $\hat{s}(e_t,z_H) = \frac{\hat{b}(e_t,z_H)}{\hat{b}(e_t,z_H) + \hat{m}(e_t,z_H)}$','Fontsize',13,'fontname','Palatino','Interpreter','Latex')
set(gca,'Fontsize',11,'fontname','Palatino','TickLabelInterpreter', 'latex');

if has_arrows 

    textar1 = text(0.5*e(1),30,'Hello');
    set(textar1,...
        'String',{'   $\underline{e}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex',...
        'color',grey);
    
    textar1 = text(1.1*e(index_switch),15,'Hello');
    set(textar1,...
        'String',{'   $e^{*}(z)$ '},...
        'FontSize',fontsize,...
        'FontName',ffont,...
        'Interpreter','Latex',...
        'color',grey);
    
    %{
    [arrowx,arrowy] = dsxy2figxy(gca, [e(1)+0.25 e(1)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$\underline{e}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color',grey);

    [arrowx,arrowy] = dsxy2figxy(gca, [e_bas(index_switch_bas)+0.25 e_bas(index_switch_bas)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$e^{*}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color','black');

    [arrowx,arrowy] = dsxy2figxy(gca, [e(index_switch)-0.25 e(index_switch)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$e^{*}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color',grey);

    [arrowx,arrowy] = dsxy2figxy(gca, [e(end)-0.25 e(end)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$\bar{e}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color',grey);

    [arrowx,arrowy] = dsxy2figxy(gca, [e_bas(end)+0.25 e_bas(end)],[2.5 0.5]);
    textar1 = annotation('textarrow',arrowx,arrowy);
    set(textar1,...
        'String',{'$\bar{e}(z_H)$'},...
        'FontSize',10,...
        'FontName','Palatino',...
        'Interpreter','Latex',...
        'FontWeight','Bold',...
        'HeadWidth',4,...
        'HeadLength',4,...
        'color','black');
    %}

end;

set(f1, 'PaperUnits', 'inches') 
set(f1, 'PaperOrientation', 'portrait');
set(f1, 'PaperSize',[10 4]);
papersize = get(gcf,'PaperSize');
width  = 10;         % Initialize a variable for width.
height = 4;          % Initialize a variable for height.
bottom = (papersize(2)- height)/2;
left = (papersize(1)- width)/2;
myfiguresize = [left-1, bottom, width+1.5, height];
set(gcf, 'PaperPosition', myfiguresize);
print(f1, '-depsc2',  graphname); 



